local addon, data = ...

_GADGETS_SCT = {}
local SCT = _GADGETS_SCT
local DEFAULT_RIFT_FONT = ""
local SCT_SIZE = nil

local _SCT_COUNT=0
--local _SCT_INSTZ={}
_SCT_INSTZ={}

local TX_NAMES = {}
local AB_NAMES = {}

local _DI = {}
local _DO = {}
local _HI = {}
local _HO = {}
local _xDO = false
local _xDI = false
local _xHO = false
local _xHI = false

local _PLAYERID

local dialog = false
local frmConfig

local x_DO, x_DI, x_HO, x_HI
local c_DO, c_DI, c_HO, c_HI
local l_DO, l_DI, l_HO, l_HI
local x_ShAb, x_ShTX, l_ShAb, l_ShTX
local x_TrAb, x_TrTX, l_TrAb, l_TrTX
local x_DOab, l_x_DOab, x_DIab, l_x_DIab
local x_HOoh, l_x_HOoh, x_HIoh, l_x_HIoh
local s_NR, l_NR
local s_FdTm, l_FdTm
local s_SZ, l_SZ
local v_normal, i_normal, t_normal
local v_crit, i_crit, t_crit
local ddFonts, ddLayout

local PHICON = "Data/\\UI\\texture\\global\\placeholder_icon.dds"

local default_settings = {
	cDI = {0.8, 0.4, 0.1, 1}, cDO = {0.8,0,0,1}, cHI = {0, 0.8, 0, 1}, cHO = {0, 0, 0.8, 1},
	nEV = 16, nFD = 6, nSZ = 12,
	xDI = true, xDO = true, xHI = true, xHO = true,
	tNM = false, tTS = false,
	xDIa = true, xDOa = true, xHIo = true, xHOo = true,
	layout = "VIA"
}

local function MergeTable(o,n)
	for k,v in pairs(n) do
		if type(v) == "table" then
			if o[k] == nil then
				o[k] = {}			
			end
	 	 	if type(o[k]) == 'table' then
	 			MergeTable(o[k], n[k])
	 	 	end
		else
			if o[k] == nil then
				o[k] = v
			end
		end
	end
end

function SCT.FontSelection(parent, label, default, listItems, sort, onchange)

	local control = UI.CreateFrame("Frame", WT.UniqueName("Control"), parent)
	control.frameIndex = getmetatable(control).__index
	setmetatable(control, WT.Control.ComboBox_mt) 

	local tfValue = UI.CreateFrame("RiftTextfield", WT.UniqueName("GadgetControlUnitSpecSelector_TextField"), control)
	tfValue:SetText(default or "")
	tfValue:SetBackgroundColor(0.2,0.2,0.2,0.9)
	control.TextField = tfValue

	if label then
		local txtLabel = UI.CreateFrame("Text", WT.UniqueName("GadgetControlUnitSpecSelector_Label"), control)
		txtLabel:SetText(label)
		txtLabel:SetPoint("TOPLEFT", control, "TOPLEFT")
		tfValue:SetPoint("CENTERLEFT", txtLabel, "CENTERRIGHT", 8, 0)
	else
		tfValue:SetPoint("TOPLEFT", control, "TOPLEFT", 0, 0)
	end	

	local dropDownIcon = UI.CreateFrame("Texture", WT.UniqueName("GadgetControlUnitSpecSelector_Dropdown"), tfValue)
	dropDownIcon:SetTexture("wtLibGadget", "img/wtDropDown.png")
	dropDownIcon:SetHeight(tfValue:GetHeight())
	dropDownIcon:SetWidth(tfValue:GetHeight())
	dropDownIcon:SetPoint("TOPLEFT", tfValue, "TOPRIGHT", -10, 0)

	--local menu = WT.Control.Menu.Create(parent, listItems, function(value) tfValue:SetText(value) end, sort)
	local menu = WT.Control.Menu.Create(parent, listItems, function(value) control:SetText(value) end, sort)
	menu:SetPoint("TOPRIGHT", dropDownIcon, "BOTTOMCENTER")
	
	local fontList = Library.Media.ListFonts()

	for k,v in pairs(menu.items) do
		if fontList[v:GetText()] == nil then
			v:SetFont("Rift", "$Flareserif_medium")
		else
			local fontDtl = Library.Media.GetFont(v:GetText())
			v:SetFont(fontDtl.addonId, fontDtl.filename)
		end
	end

	dropDownIcon.Event.LeftClick = function() menu:Toggle() end

	control.GetText = function() return tfValue:GetText() end
	control.SetText = 
		function(ctrl, value) 
			tfValue:SetText(tostring(value))
			if onchange then onchange(tostring(value)) end 
		end
		
	control:SetHeight(20)
		
	return control
			
end
function SCT.ResetTracker()
	_DO = {}
	_DI = {}
	_HO = {}
	_HI = {}
	_xDO = false
	_xDI = false
	_xHO = false
	_xHI = false
	
	for k, v in pairs(_SCT_INSTZ) do
		if v.c.xDO then
			table.insert(_DO, k)
			_xDO = true
		end
		if v.c.xDI then
			table.insert(_DI, k)
			_xDI = true
		end
		if v.c.xHO then
			table.insert(_HO, k)
			_xHO = true
		end
		if v.c.xHI then
			table.insert(_HI, k)
			_xHI = true
		end		
	end
end

function SCT.CreateRow(x, fx)
	local i = UI.CreateFrame("Texture", "i"..x, fx)
	local t = UI.CreateFrame("Text", "t"..x, i)
	--t:SetPoint("CENTERRIGHT", i, "CENTERLEFT", 0,0)
	local d = UI.CreateFrame("Text", "d"..x, i)
	--d:SetPoint("CENTERLEFT", i, "CENTERRIGHT", 0,0)
	return {i=i, t=t, d=d}
end

function SCT.Create(configuration)

	if SCT_SIZE == nil then
		SCT_SIZE = UI.CreateFrame("Text", "SCT_SIZE", WT.Context)
		SCT_SIZE:SetVisible(false)
	end
	
	MergeTable(configuration, default_settings)

	_SCT_COUNT = _SCT_COUNT+1
	configuration.index = _SCT_COUNT
	configuration.i = 1

	local SCTName = WT.UniqueName("SCT")
	local curframe = UI.CreateFrame("Frame", SCTName, WT.Context)
	local rows = {}
	local size = {}
	size.f100 = configuration.nSZ
	size.f80  = math.floor(size.f100*0.8)
	size.f150 = math.floor(size.f100*1.5)
	size.f120 = math.floor(size.f100*1.2)
		
	SCT_SIZE:SetFontSize(size.f150)
	SCT_SIZE:SetText("12345")
	size.icrit = SCT_SIZE:GetHeight()
	SCT_SIZE:SetFontSize(size.f100)
	size.inorm = SCT_SIZE:GetHeight()
	
	local font = Library.Media.GetFont(configuration.font)
	if font == nil then
		configuration.font = DEFAULT_RIFT_FONT
		font = {addonId = "Rift", filename = "$Flareserif_medium"}
	end
	
	for x=1, configuration.nEV do
		rows[x] = SCT.CreateRow(x, curframe)
		if x==1 then
			rows[x].i:SetPoint("TOPCENTER", curframe, "TOPCENTER", 0,0)
		else
			rows[x].i:SetPoint("TOPCENTER", rows[x-1].i, "BOTTOMCENTER", 0,0)
		end
		rows[x].t:SetFont(font.addonId, font.filename)
		rows[x].d:SetFont(font.addonId, font.filename)
		rows[x].i:SetVisible(false)
--		local cx = x/configuration.nEV
--		rows[x].t:SetBackgroundColor(cx,cx,cx)
--		rows[x].d:SetBackgroundColor(cx,cx,cx)
	end
	_SCT_INSTZ[_SCT_COUNT] = {f=curframe, r=rows, s=size, c=configuration, d={}, tx=0, tp=0}
	curframe:SetWidth(size.icrit)
	curframe:SetHeight(size.icrit * configuration.nEV)

	SCT.UpdateLayout(configuration)
	SCT.ResetTracker()
	
	return curframe
end

function SCT.ConfigDialog(container)
	frmConfig = UI.CreateFrame("Frame", "sctConfig", container)
	frmConfig:SetPoint("TOPLEFT", container, "TOPLEFT")
	frmConfig:SetPoint("BOTTOMRIGHT", container, "BOTTOMRIGHT", 0, -32)

	x_DO = UI.CreateFrame("SimpleCheckbox", "x_DO", frmConfig)
	x_DO:SetHeight(24)
	x_DO:SetWidth(24)
	x_DI = UI.CreateFrame("SimpleCheckbox", "x_DI", frmConfig)
	x_DI:SetHeight(24)
	x_DI:SetWidth(24)
	
	x_HO = UI.CreateFrame("SimpleCheckbox", "x_HO", frmConfig)
	x_HO:SetHeight(24)
	x_HO:SetWidth(24)
	x_HI = UI.CreateFrame("SimpleCheckbox", "x_HI", frmConfig)
	x_HI:SetHeight(24)
	x_HI:SetWidth(24)

	x_DO:SetChecked(true)
	x_DI:SetChecked(true)
	
	x_HO:SetChecked(true)
	x_HI:SetChecked(true)
	
	l_DO = UI.CreateFrame("Text", "l_DO", frmConfig)
	l_DI = UI.CreateFrame("Text", "l_DI", frmConfig)

	l_DO:SetText("Show outgoing damage")
	l_DI:SetText("Show incoming damage")
	
	l_HO = UI.CreateFrame("Text", "l_HO", frmConfig)
	l_HI = UI.CreateFrame("Text", "l_HI", frmConfig)
	
	l_HO:SetText("Show outgoing heals")
	l_HI:SetText("Show incoming heals")
	
	x_DO:SetPoint("TOPLEFT", frmConfig, "TOPLEFT", 0,0)
	x_DI:SetPoint("TOPLEFT", x_DO, "BOTTOMLEFT", 0,0)
	x_HO:SetPoint("TOPLEFT", x_DI, "BOTTOMLEFT", 0,0)
	x_HI:SetPoint("TOPLEFT", x_HO, "BOTTOMLEFT", 0,0)
	
	l_DO:SetPoint("CENTERLEFT", x_DO, "CENTERRIGHT", 0,0)
	l_DI:SetPoint("CENTERLEFT", x_DI, "CENTERRIGHT", 0,0)
	l_HO:SetPoint("CENTERLEFT", x_HO, "CENTERRIGHT", 0,0)
	l_HI:SetPoint("CENTERLEFT", x_HI, "CENTERRIGHT", 0,0)
	
	c_DO = WT.Control.ColorPicker.Create(frmConfig, "c_DO", 0.8,0,0,1)
	c_DI = WT.Control.ColorPicker.Create(frmConfig, "c_DI", 0.8,0.4,0.1,1)
	c_HO = WT.Control.ColorPicker.Create(frmConfig, "c_HO", 0,0,0.8,1)
	c_HI = WT.Control.ColorPicker.Create(frmConfig, "c_HI", 0,0.8,0,1)

	c_DO:SetWidth(40)
	c_DO:SetHeight(20)

	c_DI:SetWidth(40)
	c_DI:SetHeight(20)

	c_HO:SetWidth(40)
	c_HO:SetHeight(20)

	c_HI:SetWidth(40)
	c_HI:SetHeight(20)
	
	c_DO:SetPoint("CENTERLEFT", x_DO, "CENTERLEFT", 200, 0)
	c_DI:SetPoint("CENTERLEFT", x_DI, "CENTERLEFT", 200, 0)
	c_HO:SetPoint("CENTERLEFT", x_HO, "CENTERLEFT", 200, 0)
	c_HI:SetPoint("CENTERLEFT", x_HI, "CENTERLEFT", 200, 0)

	x_DOab = UI.CreateFrame("SimpleCheckbox", "x_DOab", frmConfig)
	x_DOab:SetHeight(24)
	x_DOab:SetWidth(24)
	x_DOab:SetChecked(true)
	x_DOab:SetPoint("TOPLEFT", x_DO, "TOPLEFT", 250,0)
	
	l_x_DOab = UI.CreateFrame("Text", "l_x_DOab", frmConfig)
	l_x_DOab:SetText("Show absorbs")
	l_x_DOab:SetPoint("CENTERLEFT", x_DOab, "CENTERRIGHT", 0,0)
	
	x_DIab = UI.CreateFrame("SimpleCheckbox", "x_DIab", frmConfig)
	x_DIab:SetHeight(24)
	x_DIab:SetWidth(24)
	x_DIab:SetChecked(true)
	x_DIab:SetPoint("TOPLEFT", x_DI, "TOPLEFT", 250,0)
	
	l_x_DIab = UI.CreateFrame("Text", "l_x_DIab", frmConfig)
	l_x_DIab:SetText("Show absorbs")
	l_x_DIab:SetPoint("CENTERLEFT", x_DIab, "CENTERRIGHT", 0,0)

	x_HOoh = UI.CreateFrame("SimpleCheckbox", "x_HOoh", frmConfig)
	x_HOoh:SetHeight(24)
	x_HOoh:SetWidth(24)
	x_HOoh:SetChecked(true)
	x_HOoh:SetPoint("TOPLEFT", x_HO, "TOPLEFT", 250,0)
	
	l_x_HOoh = UI.CreateFrame("Text", "l_x_HOoh", frmConfig)
	l_x_HOoh:SetText("Show overheals")
	l_x_HOoh:SetPoint("CENTERLEFT", x_HOoh, "CENTERRIGHT", 0,0)

	x_HIoh = UI.CreateFrame("SimpleCheckbox", "x_HIoh", frmConfig)
	x_HIoh:SetHeight(24)
	x_HIoh:SetWidth(24)
	x_HIoh:SetChecked(true)
	x_HIoh:SetPoint("TOPLEFT", x_HI, "TOPLEFT", 250,0)
	
	l_x_HIoh = UI.CreateFrame("Text", "l_x_HIoh", frmConfig)
	l_x_HIoh:SetText("Show overheals")
	l_x_HIoh:SetPoint("CENTERLEFT", x_HIoh, "CENTERRIGHT", 0,0)
	
	x_ShAb = UI.CreateFrame("SimpleCheckbox", "x_ShAb", frmConfig)
	x_ShAb:SetHeight(24)
	x_ShAb:SetWidth(24)
	x_ShAb:SetChecked(true)
	x_ShAb:SetPoint("TOPLEFT", x_HI, "BOTTOMLEFT", 0,12)
	x_ShTX = UI.CreateFrame("SimpleCheckbox", "x_ShTX", frmConfig)
	x_ShTX:SetHeight(24)
	x_ShTX:SetWidth(24)
	x_ShTX:SetChecked(true)
	x_ShTX:SetPoint("TOPLEFT", x_ShAb, "BOTTOMLEFT", 0,0)

	l_ShAb = UI.CreateFrame("Text", "l_ShAb", frmConfig)
	l_ShAb:SetText("Show ability name")
	l_ShAb:SetPoint("CENTERLEFT", x_ShAb, "CENTERRIGHT", 0,0)
	l_ShTX = UI.CreateFrame("Text", "l_ShTX", frmConfig)
	l_ShTX:SetText("Show event target/source")
	l_ShTX:SetPoint("CENTERLEFT", x_ShTX, "CENTERRIGHT", 0,0)

	x_TrAb = UI.CreateFrame("SimpleCheckbox", "x_TrAb", frmConfig)
	x_TrAb:SetHeight(24)
	x_TrAb:SetWidth(24)
	x_TrAb:SetChecked(false)
	x_TrAb:SetPoint("TOPLEFT", x_ShAb, "TOPLEFT", 200,0)

	x_TrTX = UI.CreateFrame("SimpleCheckbox", "x_TrTX", frmConfig)
	x_TrTX:SetHeight(24)
	x_TrTX:SetWidth(24)
	x_TrTX:SetChecked(false)
	x_TrTX:SetPoint("TOPLEFT", x_ShTX, "TOPLEFT", 200,0)

	l_TrAb = UI.CreateFrame("Text", "l_TrAb", frmConfig)
	l_TrAb:SetText("Truncate ability names")
	l_TrAb:SetPoint("CENTERLEFT", x_TrAb, "CENTERRIGHT", 0,0)
	
	l_TrTX = UI.CreateFrame("Text", "l_TrTX", frmConfig)
	l_TrTX:SetText("Truncate player names")
	l_TrTX:SetPoint("CENTERLEFT", x_TrTX, "CENTERRIGHT", 0,0)
	
	l_NR = UI.CreateFrame("Text", "l_NR", frmConfig)
	l_NR:SetText("Number of Events to show:")
	s_NR = UI.CreateFrame("SimpleSlider", "s_NR", frmConfig)
	s_NR:SetRange(1,24)
	s_NR:SetPosition(16, true)	
	l_NR:SetPoint("TOPLEFT", l_ShTX, "BOTTOMLEFT", 0,12)
	s_NR:SetPoint("TOPLEFT", l_NR, "BOTTOMLEFT", 0, 0) 

	l_FdTm = UI.CreateFrame("Text", "l_FdTm", frmConfig)
	l_FdTm:SetText("Fader timeout (s):")
	s_FdTm = UI.CreateFrame("SimpleSlider", "s_FdTm", frmConfig)
	s_FdTm:SetRange(1,10)
	s_FdTm:SetPosition(6, true)	
	
	l_FdTm:SetPoint("TOPLEFT", s_NR, "BOTTOMLEFT", 0, 0)
	s_FdTm:SetPoint("TOPLEFT", l_FdTm, "BOTTOMLEFT", 0, 0) 

	l_SZ = UI.CreateFrame("Text", "l_SZ", frmConfig)
	l_SZ:SetText("Default size:")
	s_SZ = UI.CreateFrame("SimpleSlider", "s_SZ", frmConfig)
	s_SZ:SetRange(8,24)
	s_SZ:SetPosition(12, true)	
	l_SZ:SetPoint("TOPLEFT", s_FdTm, "BOTTOMLEFT", 0, 0)
	s_SZ:SetPoint("TOPLEFT", l_SZ, "BOTTOMLEFT", 0, 0)		
	
	local fontList = Library.Media.ListFonts()
	local fonts = {}
	for k,v in pairs(fontList) do
		table.insert(fonts, {text=k, value=k})
	end
	table.sort(fonts, function(a,b) return a.text < b.text end)

	--cbFonts = WT.Control.ComboBox.Create(container, "Select Font:", DEFAULT_RIFT_FONT, fonts, nil, SCT.OnChange)
	ddFonts = SCT.FontSelection(container, "Select Font:", DEFAULT_RIFT_FONT, fonts, nil, SCT.OnChange)
	ddFonts:SetPoint("TOPLEFT", s_SZ, "BOTTOMLEFT", 0, 4)

	local layout = {
		{text="[Value][Icon][Ability]", value="VIA"},
		{text="[Value][Ability][Icon]", value="VAI"},
		{text="[Icon][Ability][Value]", value="IAV"},
		{text="[Icon][Value][Ability]", value="IVA"},
		{text="[Ability][Icon][Value]", value="AIV"},
		{text="[Ability][Value][Icon]", value="AVI"}
	}
	
	ddLayout = WT.Control.ComboBox.Create(container, "Choose Layout:", "VIA", layout, nil, SCT.LayoutOnChange)
	ddLayout:SetPoint("TOPLEFT", ddFonts, "BOTTOMLEFT", 0,4)
	
	v_normal = UI.CreateFrame("Text", "v_normal", frmConfig)
	i_normal = UI.CreateFrame("Texture", "i_normal", frmConfig)
	t_normal = UI.CreateFrame("Text", "t_normal", frmConfig)
		
	v_normal:SetText("1234")
	t_normal:SetText("Normal hit")
	i_normal:SetTexture("Rift", "ability_icons\\dark_harbor.dds")
	
	local f100 = s_SZ:GetPosition()
	local f80  = math.floor(f100 * 0.8)
	
	v_normal:SetFontSize(f100)
	local h = v_normal:GetHeight()
	i_normal:SetWidth(h)
	i_normal:SetHeight(h)
	t_normal:SetFontSize(f80)

	v_crit = UI.CreateFrame("Text", "v_crit", frmConfig)
	i_crit = UI.CreateFrame("Texture", "i_crit", frmConfig)
	t_crit = UI.CreateFrame("Text", "t_crit", frmConfig)
	
	v_crit:SetText("12345")
	t_crit:SetText("Critical hit")
	i_crit:SetTexture("Rift", "ability_icons\\dark_harbor.dds")
	
	local f150 = math.floor(f100*1.5)
	local f120 = math.floor(f100*1.2)
	v_crit:SetFontSize(f150)
	h = v_crit:GetHeight()
	i_crit:SetWidth(h)
	i_crit:SetHeight(h)
	t_crit:SetFontSize(f120)

	i_crit:SetPoint("TOPCENTER", frmConfig, "TOPCENTER", 0, ddLayout:GetBottom()-frmConfig:GetTop()+6  )
	v_crit:SetPoint("CENTERRIGHT", i_crit, "CENTERLEFT", 0, 0)
	t_crit:SetPoint("CENTERLEFT", i_crit, "CENTERRIGHT", 0,0)
	
	i_normal:SetPoint("TOPCENTER", i_crit, "BOTTOMCENTER", 0,4)
	v_normal:SetPoint("CENTERRIGHT", i_normal, "CENTERLEFT", 0, 0)
	t_normal:SetPoint("CENTERLEFT", i_normal, "CENTERRIGHT", 0,0)
		
	function s_SZ.Event:SliderChange()
		local f100 = s_SZ:GetPosition()
		local f80  = math.floor(f100 * 0.8)
		local f150 = math.floor(f100*1.5)
		local f120 = math.floor(f100*1.2)
		
		v_normal:SetFontSize(f100)
		t_normal:SetFontSize(f80)
		local h = v_normal:GetHeight()
		i_normal:SetWidth(h)
		i_normal:SetHeight(h)

		v_crit:SetFontSize(f150)
		t_crit:SetFontSize(f120)
		h = v_crit:GetHeight()
		i_crit:SetWidth(h)
		i_crit:SetHeight(h)		
	end	
	
	ddFonts:SetText(DEFAULT_RIFT_FONT)
end

function SCT.GetConfiguration()
	local config = {}
	config.xDO = x_DO:GetChecked()
	config.xDI = x_DI:GetChecked()
	config.xHO = x_HO:GetChecked()
	config.xHI = x_HI:GetChecked()
	config.cDO = { c_DO:GetColor() }
	config.cDI = { c_DI:GetColor() }
	config.cHO = { c_HO:GetColor() }
	config.cHI = { c_HI:GetColor() }
	config.xNM = x_ShAb:GetChecked()
	config.xTS = x_ShTX:GetChecked()
	config.nEV = s_NR:GetPosition()
	config.nFD = s_FdTm:GetPosition()
	config.nSZ = s_SZ:GetPosition()
	config.tNM = x_TrAb:GetChecked()
	config.tTS = x_TrTX:GetChecked()
	config.xDIa= x_DIab:GetChecked()
	config.xDOa= x_DOab:GetChecked()
	config.xHIo= x_HIoh:GetChecked()
	config.xHOo= x_HOoh:GetChecked()
	config.font= ddFonts:GetText()
	config.layout= ddLayout:GetText()
	return config
end

function SCT.SetConfiguration(config)
	x_DO:SetChecked(config.xDO)
	x_DI:SetChecked(config.xDI)
	x_HO:SetChecked(config.xHO)
	x_HI:SetChecked(config.xHI)
	c_DO:SetColor(unpack(config.cDO))
	c_DI:SetColor(unpack(config.cDI))
	c_HO:SetColor(unpack(config.cHO))
	c_HI:SetColor(unpack(config.cHI))
	x_ShAb:SetChecked(config.xNM)
	x_ShTX:SetChecked(config.xTS)
	s_NR:SetPosition(config.nEV)
	s_FdTm:SetPosition(config.nFD)
	s_SZ:SetPosition(config.nSZ)
	x_TrAb:SetChecked(config.tNM)
	x_TrTX:SetChecked(config.tTS)
	x_DIab:SetChecked(config.xDIa)
	x_DOab:SetChecked(config.xDOa)
	x_HIoh:SetChecked(config.xHIo)
	x_HOoh:SetChecked(config.xHOo)
	if Library.Media.GetFont(config.font) == nil then
		config.font=DEFAULT_RIFT_FONT
	end
	ddFonts:SetText(config.font)
	ddLayout:SetText(config.layout)
end

function SCT.LayoutOnChange(t)
	v_crit:ClearPoint("TOPLEFT")
	v_crit:ClearPoint("TOPRIGHT")
	t_crit:ClearPoint("TOPLEFT")
	t_crit:ClearPoint("TOPRIGHT")
	v_normal:ClearPoint("TOPLEFT")
	v_normal:ClearPoint("TOPRIGHT")
	t_normal:ClearPoint("TOPLEFT")
	t_normal:ClearPoint("TOPRIGHT")
	
	if t == "VIA" then
		v_crit:SetPoint("CENTERRIGHT", i_crit, "CENTERLEFT", 0, 0)
		t_crit:SetPoint("CENTERLEFT", i_crit, "CENTERRIGHT", 0,0)	
		v_normal:SetPoint("CENTERRIGHT", i_normal, "CENTERLEFT", 0, 0)
		t_normal:SetPoint("CENTERLEFT", i_normal, "CENTERRIGHT", 0,0)
	elseif t == "AIV" then
		v_crit:SetPoint("CENTERLEFT", i_crit, "CENTERRIGHT", 0, 0)
		t_crit:SetPoint("CENTERRIGHT", i_crit, "CENTERLEFT", 0,0)	
		v_normal:SetPoint("CENTERLEFT", i_normal, "CENTERRIGHT", 0, 0)
		t_normal:SetPoint("CENTERRIGHT", i_normal, "CENTERLEFT", 0,0)
	elseif t == "VAI" then
		t_crit:SetPoint("CENTERRIGHT", i_crit, "CENTERLEFT", 0,0)	
		v_crit:SetPoint("CENTERRIGHT", t_crit, "CENTERLEFT", 0, 0)
		t_normal:SetPoint("CENTERRIGHT", i_normal, "CENTERLEFT", 0,0)
		v_normal:SetPoint("CENTERRIGHT", t_normal, "CENTERLEFT", 0, 0)
	elseif t == "AVI" then
		t_crit:SetPoint("CENTERRIGHT", v_crit, "CENTERLEFT", 0,0)	
		v_crit:SetPoint("CENTERRIGHT", i_crit, "CENTERLEFT", 0, 0)
		t_normal:SetPoint("CENTERRIGHT", v_normal, "CENTERLEFT", 0,0)
		v_normal:SetPoint("CENTERRIGHT", i_normal, "CENTERLEFT", 0, 0)
	elseif t == "IVA" then
		t_crit:SetPoint("CENTERLEFT", v_crit, "CENTERRIGHT", 0,0)	
		v_crit:SetPoint("CENTERLEFT", i_crit, "CENTERRIGHT", 0, 0)
		t_normal:SetPoint("CENTERLEFT", v_normal, "CENTERRIGHT", 0,0)
		v_normal:SetPoint("CENTERLEFT", i_normal, "CENTERRIGHT", 0, 0)
	else -- IAV
		t_crit:SetPoint("CENTERLEFT", i_crit, "CENTERRIGHT", 0,0)	
		v_crit:SetPoint("CENTERLEFT", t_crit, "CENTERRIGHT", 0, 0)
		t_normal:SetPoint("CENTERLEFT", i_normal, "CENTERRIGHT", 0,0)
		v_normal:SetPoint("CENTERLEFT", t_normal, "CENTERRIGHT", 0, 0)
	end
end

function SCT.OnChange(t)
	local font = Library.Media.GetFont(t)
	if font == nil then
		ddFonts:SetText(DEFAULT_RIFT_FONT)
	end
	v_normal:SetFont(font.addonId, font.filename)
	t_normal:SetFont(font.addonId, font.filename)
	v_crit:SetFont(font.addonId, font.filename)
	t_crit:SetFont(font.addonId, font.filename)
end

function SCT.UpdateLayout(c)
	for x=1, c.nEV do
		_SCT_INSTZ[c.index].r[x].d:ClearPoint("CENTERRIGHT")
		_SCT_INSTZ[c.index].r[x].d:ClearPoint("CENTERLEFT")
		_SCT_INSTZ[c.index].r[x].t:ClearPoint("CENTERRIGHT")
		_SCT_INSTZ[c.index].r[x].t:ClearPoint("CENTERLEFT")

		if c.layout == "VIA" then
			_SCT_INSTZ[c.index].r[x].d:SetPoint("CENTERRIGHT", _SCT_INSTZ[c.index].r[x].i, "CENTERLEFT", 0, 0)
			_SCT_INSTZ[c.index].r[x].t:SetPoint("CENTERLEFT", _SCT_INSTZ[c.index].r[x].i, "CENTERRIGHT", 0,0)	
		elseif c.layout == "AIV" then
			_SCT_INSTZ[c.index].r[x].d:SetPoint("CENTERLEFT", _SCT_INSTZ[c.index].r[x].i, "CENTERRIGHT", 0, 0)
			_SCT_INSTZ[c.index].r[x].t:SetPoint("CENTERRIGHT", _SCT_INSTZ[c.index].r[x].i, "CENTERLEFT", 0,0)	
		elseif c.layout == "VAI" then
			_SCT_INSTZ[c.index].r[x].t:SetPoint("CENTERRIGHT", _SCT_INSTZ[c.index].r[x].i, "CENTERLEFT", 0,0)	
			_SCT_INSTZ[c.index].r[x].d:SetPoint("CENTERRIGHT", _SCT_INSTZ[c.index].r[x].t, "CENTERLEFT", 0, 0)
		elseif c.layout == "AVI" then
			_SCT_INSTZ[c.index].r[x].t:SetPoint("CENTERRIGHT", _SCT_INSTZ[c.index].r[x].d, "CENTERLEFT", 0,0)	
			_SCT_INSTZ[c.index].r[x].d:SetPoint("CENTERRIGHT", _SCT_INSTZ[c.index].r[x].i, "CENTERLEFT", 0, 0)
		elseif c.layout == "IVA" then
			_SCT_INSTZ[c.index].r[x].t:SetPoint("CENTERLEFT", _SCT_INSTZ[c.index].r[x].d, "CENTERRIGHT", 0,0)	
			_SCT_INSTZ[c.index].r[x].d:SetPoint("CENTERLEFT", _SCT_INSTZ[c.index].r[x].i, "CENTERRIGHT", 0, 0)
		else -- IAV
			_SCT_INSTZ[c.index].r[x].t:SetPoint("CENTERLEFT", _SCT_INSTZ[c.index].r[x].i, "CENTERRIGHT", 0,0)	
			_SCT_INSTZ[c.index].r[x].d:SetPoint("CENTERLEFT", _SCT_INSTZ[c.index].r[x].t, "CENTERRIGHT", 0, 0)
		end		
	end
end

function SCT.Reconfigure(a)
	local nf = #_SCT_INSTZ[a.index].r
	local font = Library.Media.GetFont(a.font)
	if font == nil then
		font = {addonId = "Rift", filename = "$Flareserif_medium"}
		a.font = DEFAULT_RIFT_FONT
	end
	if a.nEV > nf then
		for x=nf+1, a.nEV do
			_SCT_INSTZ[a.index].r[x] = SCT.CreateRow(x, _SCT_INSTZ[a.index].f)
			_SCT_INSTZ[a.index].r[x].i:SetPoint("TOPCENTER", _SCT_INSTZ[a.index].r[x-1].i, "BOTTOMCENTER", 0,0)
			_SCT_INSTZ[a.index].r[x].i:SetVisible(false)
		end
	elseif a.nEV < nf then
		for x=a.nEV+1, nf do
			_SCT_INSTZ[a.index].r[x].i:SetVisible(false)
		end
	end
	
	for x=1, a.nEV do
		_SCT_INSTZ[a.index].r[x].t:SetFont(font.addonId, font.filename)
		_SCT_INSTZ[a.index].r[x].d:SetFont(font.addonId, font.filename)
	end

	if a.nSZ ~= _SCT_INSTZ[a.index].s.f100 then
		_SCT_INSTZ[a.index].s.f100 = a.nSZ
		_SCT_INSTZ[a.index].s.f80  = math.floor(_SCT_INSTZ[a.index].s.f100*0.8)
		_SCT_INSTZ[a.index].s.f150 = math.floor(_SCT_INSTZ[a.index].s.f100*1.5)
		_SCT_INSTZ[a.index].s.f120 = math.floor(_SCT_INSTZ[a.index].s.f100*1.2)
		SCT_SIZE:SetFontSize(_SCT_INSTZ[a.index].s.f150)
		_SCT_INSTZ[a.index].s.icrit = SCT_SIZE:GetHeight()
		SCT_SIZE:SetFontSize(_SCT_INSTZ[a.index].s.f100)
		_SCT_INSTZ[a.index].s.inorm = SCT_SIZE:GetHeight()
	end	
	
	_SCT_INSTZ[a.index].f:SetWidth(_SCT_INSTZ[a.index].s.icrit)
	_SCT_INSTZ[a.index].f:SetHeight(_SCT_INSTZ[a.index].s.icrit * a.nEV)
	_SCT_INSTZ[a.index].c = a
	
	SCT.UpdateLayout(a)
	SCT.ResetTracker()
end

WT.Gadget.RegisterFactory("SCT",
	{
		name="Scrolling Combat Text",
		description="Shows combat events",
		author="Adelea@Icewatch-EU",
		version=addon.toc.Version,
		iconTexAddon=addon.identifier,
		iconTexFile="img/scroll.png",
		["Create"] =SCT.Create,
		["ConfigDialog"] = SCT.ConfigDialog,
		["Reconfigure"] = SCT.Reconfigure,
		["GetConfiguration"] = SCT.GetConfiguration, 
		["SetConfiguration"] = SCT.SetConfiguration, 
	})

function SCT.Event_Addon_SavedVariables_Load_End(a)
	if a ~= addon.identifier then
		return
	end
end

local ABILITYDETAILS = {}

function SCT.GetAbilityIcon(a)
	if a ~= nil then
		local d = Inspect.Ability.New.Detail(a)
		if d ~= nil then
			ABILITYDETAILS[a] = d.icon
		end
	end
end

function SCT.Event_Generic_MDP(t, i)
	if i.target == _PLAYERID and _xDI then
		if ABILITYDETAILS[i.abilityNew] == nil then
			SCT.GetAbilityIcon(i.abilityNew)
		end
		for k,v in pairs(_DI) do
			table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.casterName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=t, cx=false, t="DI"})
		end
	elseif i.caster == _PLAYERID and _xDO then
		if ABILITYDETAILS[i.abilityNew] == nil then
			SCT.GetAbilityIcon(i.abilityNew)
		end
		for k,v in pairs(_DO) do
			table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.targetName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=t, cx=false, t="DO"})
		end
	end
end

function SCT.Event_Combat_Immune(i)
	SCT.Event_Generic_MDP("IMMUNE", i)
end

function SCT.Event_Combat_Resist(i)
	SCT.Event_Generic_MDP("RESIST", i)
end

function SCT.Event_Combat_Miss(i)
	SCT.Event_Generic_MDP("MISS", i)
end

function SCT.Event_Combat_Dodge(i)
	SCT.Event_Generic_MDP("DODGE", i)
end

function SCT.Event_Combat_Parry(i)
	SCT.Event_Generic_MDP("PARRY", i)
end

function SCT.Event_Combat_Heal(i) 
	if i.target == _PLAYERID and _xHI then
		if ABILITYDETAILS[i.abilityNew] == nil then
			SCT.GetAbilityIcon(i.abilityNew)
		end
		
		local ha = i.heal or 0
		local oh = i.overheal or 0
		
		for k,v in pairs(_HI) do
			if _SCT_INSTZ[v].c.xHIo and oh > 0 then
				table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.casterName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=string.format("%d (%d)", ha, oh), cx=i.crit or false, t="HI"})
			elseif ha > 0 then
				table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.casterName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=string.format("%d", ha), cx=i.crit or false, t="HI"})
			end
		end
	end
	if i.caster == _PLAYERID and _xHO then
		if ABILITYDETAILS[i.abilityNew] == nil then
			SCT.GetAbilityIcon(i.abilityNew)
		end

		local ha = i.heal or 0
		local oh = i.overheal or 0
		
		for k,v in pairs(_HO) do
			if _SCT_INSTZ[v].c.xHOo and oh > 0 then
				table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.targetName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=string.format("%d (%d)", ha, oh), cx=i.crit or false, t="HO"})
			elseif ha > 0 then
				table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.targetName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=string.format("%d", ha), cx=i.crit or false, t="HO"})
			end
		end
	end
end

function SCT.Event_Combat_Damage(i) 
	if i.target == _PLAYERID and _xDI then
		if ABILITYDETAILS[i.abilityNew] == nil then
			SCT.GetAbilityIcon(i.abilityNew)
		end
		
		local da = i.damage or 0
		local ab = i.damageAbsorbed or 0	
		local db = ""
		if i.damageBlocked ~= nil then
			db = string.format("(BLK: %d) ", i.damageBlocked)
		elseif i.damageDeflected ~= nil then
			db = string.format("(DFL: %d) ", i.damageDeflected)
		end

		for k,v in pairs(_DI) do
			if _SCT_INSTZ[v].c.xDIa and ab ~= 0 then
				table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.casterName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=string.format("(ABS: %d) %s%d",math.abs(ab),db,da), cx=i.crit or false, t="DI"})
			elseif da > 0 then
				table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.casterName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=string.format("%s%d",db,da), cx=i.crit or false, t="DI"})
			end
		end
	end
	if i.caster == _PLAYERID and _xDO then
		if ABILITYDETAILS[i.abilityNew] == nil then
			SCT.GetAbilityIcon(i.abilityNew)
		end

		local da = i.damage or 0
		local ab = i.damageAbsorbed or 0
		local db = ""
		
		if i.damageBlocked ~= nil then
			db = string.format("(BLK: %d) ", i.damageBlocked)
		elseif i.damageDeflected ~= nil then
			db = string.format("(DFL: %d) ", i.damageDeflected)
		end

		for k,v in pairs(_DO) do
			if _SCT_INSTZ[v].c.xDOa and ab ~= 0 then
				table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.targetName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=string.format("(ABS: %d) %s%d",math.abs(ab),db,da), cx=i.crit or false, t="DO"})
			elseif da > 0 then
				table.insert(_SCT_INSTZ[v].d, 1, {tx=Inspect.Time.Real(), an=i.abilityName, xn=i.targetName or "", i=ABILITYDETAILS[i.abilityNew] or PHICON, v=string.format("%s%d",db,da), cx=i.crit or false, t="DO"})
			end
		end
	end
end

local function truncate_name(n, b)
	if b then
		if TX_NAMES[n] == nil then
			local x = string.find(n, "@")
			if x == nil then
				TX_NAMES[n] = n
			else
				TX_NAMES[n] = string.sub(n, 1, (x-1))
			end
		end
		return TX_NAMES[n]
	else
		return n
	end
end

local function truncate_ability(n, b)
	if b then
		if AB_NAMES[n] == nil then
			local x = ""
			for t in string.gmatch(n, "[^%s]+") do
				x = x..string.sub(t,1,1)
			end
			AB_NAMES[n] = x
		end
		return AB_NAMES[n]
	else
		return n
	end
end

function SCT.Event_System_Update_Begin()
	local tn = Inspect.Time.Real()
	local tname = ""
	local aname = ""
	for k,v in pairs(_SCT_INSTZ) do
		for i,d in pairs(v.d) do
			if i <= v.c.nEV then
				if v.d[1].tx > v.tx then
					for x=1, v.c.nEV do
						if v.d[x] ~= nil then
							if v.d[x].t == "DO" then
								v.r[x].t:SetFontColor(_SCT_INSTZ[k].c.cDO[1], _SCT_INSTZ[k].c.cDO[2], _SCT_INSTZ[k].c.cDO[3],1)
								v.r[x].d:SetFontColor(_SCT_INSTZ[k].c.cDO[1], _SCT_INSTZ[k].c.cDO[2], _SCT_INSTZ[k].c.cDO[3],1)
							elseif v.d[x].t == "DI" then
								v.r[x].t:SetFontColor(_SCT_INSTZ[k].c.cDI[1], _SCT_INSTZ[k].c.cDI[2], _SCT_INSTZ[k].c.cDI[3],1)
								v.r[x].d:SetFontColor(_SCT_INSTZ[k].c.cDI[1], _SCT_INSTZ[k].c.cDI[2], _SCT_INSTZ[k].c.cDI[3],1)
							elseif v.d[x].t == "HI" then
								v.r[x].t:SetFontColor(_SCT_INSTZ[k].c.cHI[1], _SCT_INSTZ[k].c.cHI[2], _SCT_INSTZ[k].c.cHI[3],1)
								v.r[x].d:SetFontColor(_SCT_INSTZ[k].c.cHI[1], _SCT_INSTZ[k].c.cHI[2], _SCT_INSTZ[k].c.cHI[3],1)
							elseif v.d[x].t == "HO" then
								v.r[x].t:SetFontColor(_SCT_INSTZ[k].c.cHO[1], _SCT_INSTZ[k].c.cHO[2], _SCT_INSTZ[k].c.cHO[3],1)
								v.r[x].d:SetFontColor(_SCT_INSTZ[k].c.cHO[1], _SCT_INSTZ[k].c.cHO[2], _SCT_INSTZ[k].c.cHO[3],1)
							end
							v.r[x].i:SetVisible(true)
							v.r[x].i:SetTexture("Rift", v.d[x].i)
							v.r[x].t:SetText(string.format("%s", v.d[x].v))
							if v.c.xNM and v.c.xTS then
								v.r[x].d:SetText(string.format("%s [%s]", truncate_name(v.d[x].xn, v.c.tTS), truncate_ability(v.d[x].an, v.c.tNM)))
							elseif v.c.xTS then
								v.r[x].d:SetText(string.format("%s", truncate_name(v.d[x].xn, v.c.tTS)))
							elseif v.c.xNM then
								v.r[x].d:SetText(string.format("%s", truncate_ability(v.d[x].an, v.c.tNM)))
							else
								v.r[x].d:SetText("")
							end
							if v.d[x].cx then
								v.r[x].i:SetWidth(v.s.icrit)
								v.r[x].i:SetHeight(v.s.icrit)
								v.r[x].t:SetFontSize(v.s.f150)
								v.r[x].d:SetFontSize(v.s.f120)
								--print(string.format("X=%d, f120=%d, f150=%d", x, v.s.f120, v.s.f150))
							else
								v.r[x].i:SetWidth(v.s.inorm)
								v.r[x].i:SetHeight(v.s.inorm)
								v.r[x].t:SetFontSize(v.s.f100)
								v.r[x].d:SetFontSize(v.s.f80)
								--print(string.format("X=%d, f80=%d, f100=%d", x, v.s.f80, v.s.f100))
							end							
						else
							v.r[x].i:SetVisible(false)
						end
					end
					v.tx = v.d[1].tx
				end
			
				local td = tn - d.tx
				if td > v.c.nFD then
					if td - v.c.nFD >= 2 then
						v.r[i].i:SetVisible(false)
					else
						local a = 1-((td-v.c.nFD)/2)
						v.r[i].i:SetAlpha(a)
						v.r[i].t:SetAlpha(a)
						v.r[i].d:SetAlpha(a)
					end
				else
					v.r[i].i:SetAlpha(1)
					v.r[i].t:SetAlpha(1)
					v.r[i].d:SetAlpha(1)				
				end
			end
		end
		if tn - v.tp > 20 then
			if #v.d > 100 then
				--print(string.format("Purging %d records from set# %d", #v.d-100, k))
				for x=#v.d, 100, -1 do
					v.d[x] = nil
				end
				v.tp = tn
			end
		end
	end
end

local fontList = Library.Media.ListFonts()
local defRiftFont = false
for k,v in pairs(fontList) do
	if v.addonId == "Rift" and v.filename == "$Flareserif_medium" then
		DEFAULT_RIFT_FONT = k
		defRiftFont = true
		break
	end
end

if defRiftFont == false then
	if fontList["$Flareserif_medium"] == nil then
		Library.Media.AddFont("$Flareserif_medium", "Rift", "$Flareserif_medium")
	end
	DEFAULT_RIFT_FONT = "$Flareserif_medium"
end

Library.Media.AddFont("ObelixPro", addon.identifier, "fonts/ObelixPro-cyr.ttf")
Library.Media.AddFont("ObelixProBroken", addon.identifier, "fonts/ObelixPro-Broken-cyr.ttf")
Library.Media.AddFont("Kronika", addon.identifier, "fonts/KRONIKA_.ttf")

table.insert(Event.Addon.SavedVariables.Load.End, { SCT.Event_Addon_SavedVariables_Load_End, addon.identifier, "Event.Addon.SavedVariables.Load.End" })
table.insert(Event.Combat.Damage, {SCT.Event_Combat_Damage, addon.identifier, "Event.Combat.Damage"})
table.insert(Event.Combat.Heal, {SCT.Event_Combat_Heal, addon.identifier, "Event.Combat.Heal"})
table.insert(Event.Combat.Miss, {SCT.Event_Combat_Miss, addon.identifier, "Event.Combat.Miss"})
table.insert(Event.Combat.Parry, {SCT.Event_Combat_Parry, addon.identifier, "Event.Combat.Parry"})
table.insert(Event.Combat.Dodge, {SCT.Event_Combat_Dodge, addon.identifier, "Event.Combat.Dodge"})
table.insert(Event.Combat.Parry, {SCT.Event_Combat_Parry, addon.identifier, "Event.Combat.Parry"})
table.insert(Event.Combat.Resist, {SCT.Event_Combat_Resist, addon.identifier, "Event.Combat.Resist"})
table.insert(Event.Combat.Immune, {SCT.Event_Combat_Immune, addon.identifier, "Event.Combat.Immune"})
table.insert(Event.System.Update.Begin, { SCT.Event_System_Update_Begin, addon.identifier, "Event.System.Update.Begin" })

_PLAYERID = Inspect.Unit.Lookup("player")
